    var deviceControl;

    var commandMap = {
      'Home' : "Home",
      'Rewind' : "Rev",
      'Fast_Forward' : "Fwd",
      'Play' : "Play",
      'Select' : "Select",
      'Navigate_Left' : "Left",
      'Navigate_Right' : "Right",
      'Navigate_Down' : "Down",
      'Navigate_Up' : "Up",
      'Back' : "Back",
      'InstantReplay' : "InstantReplay",
      'Options' : "Info",
      'Backspace' : "Backspace",
      'Search' : "Search",
      'Enter' : "Enter"
    }

    function sendCommand(command) {
      var rokuCommand = commandMap[command];
      if (rokuCommand === undefined) {
          log("ERROR", "Error! Roku command undefined:" + rokuCommand);
      } else {
        if (deviceControl === undefined) {
            log("ERROR", "sendCommand error. devicecontrol is undefined.");
        } else {
            var endPoint = "http://"+ deviceControl.ip + ":" + deviceControl.port + "/keypress/" + rokuCommand;
            sendRokuCommandUrl(endPoint, command);
        }
      }
    }

   var sendRokuCommandUrl;
   var rokuApp = angular.module('rokuApp', []);
   rokuApp.controller('rokuCtrl', function($scope, $http) {
       $scope.sendRokuCommand = function(endPoint, command) {
       log("DEBUG", "sending roku command to: " + endPoint);
          $http({
                     method: 'POST',
                     url: endPoint,
                     headers: {'Content-Type': 'application/x-www-form-urlencoded'}
                 }).then(function successCallback(response) {
                     log("DEBUG", "send roku command to endpoint: " + endPoint + " successfully.");
                     Android.logCommandSentEvent(true, command);
                 }, function errorCallback(response) {
                     log("DEBUG", "send roku command to endpoint: " + endPoint + " failed." + response.status);
                     Android.logCommandSentEvent(false, command);
                 });
       };
       sendRokuCommandUrl = $scope.sendRokuCommand;
    });
