function log(level, msg) {
    try {
        //For PSR only
        Android.log(level, msg);
    } catch (err) {
        console.log(msg);
    }
}

function buildDeviceInfo(brand, deviceType, modelName, ip) {
	var str = brand + " " + getDeviceNameById(deviceType) + " ";
	if (modelName !== undefined) {
		str += "(" + modelName + ") "
	}
	
	if (ip !== undefined) {
		str += "IP: " + ip;
	}
	
	return str;
}

function getDeviceNameById(deviceType) {
	 var name = "device";
        switch (deviceType) {
            case 1:
                name = "TV"; 
                break;
            case 2:
                name = "STB";
                break;
            case 3:
                name = "DVD";
                break;
            case 4:
                name = "Blu-ray";
                break;
            case 5:
                name = "AV Receiver";
                break;
            case 6:
                name = "SMP";
                break;
            case 10:
                name = "Projector";
                break;
            case 13:
                name = "Home Theater";
                break;
            case 18:
                name = "AC";
                break;
            case 20:
                name = "DVR";
                break;
            case 23:
                name = "Soundbar";
                break;    
            case 24:
                name = "HDMI Switch";
                break;
            case 25:
                name = "Camera";
                break;
            case 26:
                name = "Air Cooler";
                break;
            case 30:
                name = "Light";
                break;
            case 31:
                name = "Switch";
                break; 
            case 33:
                name = "Thermostat";
                break; 
            case 34:
                name = "Helicopter";
                break;                                                             
        }
        return name;
	
	
}

var highlightingButtons = function(event, command) {
    if (command === 'Volume_Up' || command === 'Volume_Down' || command === 'Channel_Up' || command === 'Channel_Down' || command === 'Navigate_Up' || command === 'Navigate_Left' || command === 'Navigate_Down' || command === 'Navigate_Right') {
        event.target.nextSibling.nextSibling.style.display = 'block';
        setTimeout(function() {
            event.target.nextSibling.nextSibling.style.display = 'none';
        }, 50);
    } else if (command === 'Fast_Forward' || command === 'Rewind' || command === 'Pause' || command === 'Play' || command === 'Stop' || command === 'Skip_Back' || command === 'Skip_Forward' || command === 'Next' || command === 'Previous' || command === 'Record') {
        if (command === 'Fast_Forward') {
            event.target.parentNode.style.backgroundImage = "url('../lib/base/images/remote_media_pad_a4_press.png')";
            setTimeout(function() {
                event.target.parentNode.style.backgroundImage = "url('../lib/base/images/remote_media_pad_a4.png')";
            }, 50);
        } else if (command === 'Rewind') {
            event.target.parentNode.style.backgroundImage = "url('../lib/base/images/remote_media_pad_a1_press.png')";
            setTimeout(function() {
                event.target.parentNode.style.backgroundImage = "url('../lib/base/images/remote_media_pad_a1.png')";
            }, 50);
        } else if(command === 'Stop' || command === 'Skip_Back' || command === 'Skip_Forward' || command === 'Next' || command === 'Previous' || command === 'Record'){
            event.target.parentNode.style.backgroundImage = "url('../lib/base/images/remote_media_pad_a2_3_press.png')";
            setTimeout(function() {
                event.target.parentNode.style.backgroundImage = "url('../lib/base/images/remote_media_pad_a6_7.png')";
            }, 50);
        }else {
            event.target.parentNode.style.backgroundImage = "url('../lib/base/images/remote_media_pad_a2_3_press.png')";
            setTimeout(function() {
                event.target.parentNode.style.backgroundImage = "url('../lib/base/images/remote_media_pad_a2_3.png')";
            }, 50);
        }
    } else if (command !== 'Select' && command !== 'Backspace' && command.indexOf("Lit_") === -1) {
        event.target.parentNode.style.backgroundImage = "url('../lib/base/images/common_btn_press.png')";
        setTimeout(function() {
            event.target.parentNode.style.backgroundImage = "url('../lib/base/images/common_btn_normal.png')";
        }, 50);
    }
}

var sendInsightEvent = function(status, command) {
    try {
        Android.logCommandSentEvent(status, command);
    } catch (e) {
        log("DEBUG", "Android interface not found");
    }
}

var sendPairingResultEvent = function(status, deviceType, brand){
    try {
        Android.logPairingResultEvent(status, deviceType, brand);
    } catch (e) {
        log("DEBUG", "Android interface not found");
    }
}

var sendPairingEvent = function(deviceType, brand, action, source){
    try {
        Android.logPairingEvent(deviceType, brand, action, source);
    } catch (e) {
        log("DEBUG", "Android interface not found");
    }
}

var toggleAlertMessage = function(state) {
    if (document.getElementById("alert-message")) {
        document.getElementById("alert-message").style.display = state;
    }
}

var sendRemoteButtonPressed = function(contexId, brand, command, source){
    try {
        Android.logRemoteButtonPressedEvent(contexId, brand, command, source);
    } catch (e) {
        log("DEBUG", "Android interface not found");
    }
}

var sendCommandDetailSentEvent = function(success , command, contextId, source){
    try {
        Android.logCommandDetailSentEvent(success , command, contextId, source);
    } catch (error) {
        log("DEBUG", "Android interface not found");
    }
}

var getSource = function(contextId){
    log("DEBUG", "contextId: "+ contextId);
    var source = '';
    switch(contextId){
        case 151:
            source = 'inapp';
            break;
        case 148:
            source = 'widget';
            break;
        case 144:
            source = 'overlay/notification';
    }
    log("DEBUG", "source: "+ source);
    return source;
}

var getContextIdAndSource = function(contextId){
    var source;
    try {
        contextId = contextId
            .toString();
    } catch (error) {
        log("DEBUG", "device has no contextID");
    }
    if (contextId) {
        contextId = contextId === '0' ? 144 : contextId;
        contextId = parseInt(contextId);
        source = getSource(contextId);
    } else {
        contextId = 151;
        source = "inapp";
    }

    return {"contextId": contextId, "source": source};
}