var device = {
    "ip": "192.168.1.38",
    "port": "8080",	 
	"contextId":151, 
    "source":"inapp"
};
var pressTimer;

var commandTimeout;

var startTimer = function(event, command) {
    pressTimer = setTimeout(function() {
        sendSamsungCommand(event, command);
        startTimer(event, command);
    }, 200);
}

var clearTimer = function() {
    clearTimeout(pressTimer);
}

var sendSamsungCommand = function(event, command) {
    highlightingButtons(event, command);
    sendDeviceCommand(command, "inApp");
}

var is_tv_active = function(command) {
    removeCommandTimeout();
    commandTimeout = setTimeout(function() {
        toggleAlertMessage('block');
    }, 2000);
    log("DEBUG", "is_tv_active : " + command);
    try {
        fetch(`http://${device.ip}:${device.port}/smp_6_`, { mode: 'no-cors' }).then(function(resposne) {
            log("DEBUG", "is_tv_active : true");
            removeCommandTimeout();
            toggleAlertMessage('none');
        }).catch(function(e) {
            toggleAlertMessage('none');
            removeCommandTimeout();
            log("DEBUG", "is_tv_active in fetch catch : true");
            log("ERROR", "err : " + e.message);
        });
    } catch (e) {
        toggleAlertMessage('block');
        log("DEBUG", "is_tv_active in try catch : false");
        log("ERROR", "err : " + e);
    }

}

var removeCommandTimeout = function() {
    if (commandTimeout) {
        clearTimeout(commandTimeout);
        commandTimeout = null;
    }
}

function sendDeviceCommand(command, location) {
    if (command === 'Power') {
        command = 'PowerOff';
    }
    is_tv_active(command);
    log("DEBUG", "command Sent : " + command);
    try {
        sendCommandDetailSentEvent(true, command, device.contextId, getSource(device.contextId));
    } catch (errors) {
        sendInsightEvent(true, command);                    
    }
    if (command === undefined) {
        log("ERROR", "Error! command undefined:" + command);
    } else {
        try {
            Android.sendCommand(command);
        } catch (err) {				
            try {
                sendCommandDetailSentEvent(false, command, device.contextId, getSource(device.contextId));
            } catch (errors) {
                sendInsightEvent(false, command);                    
            }
            log("DEBUG", "Samsung pre2013 TV send command:" + command);
        }
    }
}


function initDeviceInfo() {
    try {
        device = JSON.parse(getInfo('currentDevice'));
        log("DEBUG", JSON.stringify(device));
        if (device.modelNumber) {
            if (device.friendlyName){
                document.getElementById("deviceInfo").innerHTML = `${device.modelNumber} - ${device.friendlyName}`;
            }
            else {
                document.getElementById("deviceInfo").innerHTML = `${device.brandName} - ${device.modelNumber}`;
            }
        }
    } catch (err) {
        log("ERROR", "Unable to initialize device info: " + err);
    }
}

function getInfo(value) {
    var info = "empty";
    switch (value) {
        case "currentDevice":
            info = Android.getCurrentDeviceInfo();
            break;
        case "currentActivity":
            info = Android.getCurrentActivityInfo();
            break;
        case "currentRoom":
            info = Android.getCurrentRoomInfo();
            break;
    }
    return info;
}