'use strict';

var deviceIp;

// var device = {
//     "ip": "10.0.0.64",
//     "port": "9000",
// 	"contextId":151,
//     "source":"inapp"
// };


var device = {
    "ip": "192.168.50.97",
    "port": "9000",
    "contextId":151,
    "source":"inapp"
};

var pressTimer;
var isCheckPair = true;
var isPaired = false;
var commandSent = '';
var commandSentLocation;
var connectionState = "";
var requestTimeout;
var isPairingTriggeredFromLockPanel = false;

let _pairingRequestToken = '',
    _authKey = '',
    _deviceId = '',
    _deviceName = '';

var removeRequestTimeout = function () {
    if (requestTimeout) {
        clearTimeout(requestTimeout);
        requestTimeout = null;
    }
}

function initDeviceInfo() {
    try {
        device = JSON.parse(getInfo('currentDevice'));
        log("DEBUG", "Device: " + JSON.stringify(device));
        log("DEBUG", device.ip + " " + device.port);
        if (device.modelNumber) {
            if (device.friendlyName){
                document.getElementById("deviceInfo").innerHTML = `${device.modelNumber} - ${device.friendlyName}`;
            }
            else {
                document.getElementById("deviceInfo").innerHTML = `${device.brandName} - ${device.modelNumber}`;
            }
        }
        var localStoredData = localStorage.getItem(device.ip);
        log("DEBUG", "localStoredData: " + localStoredData);
        if (localStoredData) {
            try {
                localStoredData = JSON.parse(localStoredData);
                log("DEBUG", "There is localStoredData");
                log("DEBUG", "commandSentLocation : " + localStoredData.commandSentLocation);
                if (localStoredData.commandSentLocation && localStoredData.commandSentLocation === 'widget') {
                    let commandSent = localStoredData.commandSent;
                    log("DEBUG", "commandSentLocation : " + commandSent);
                    localStorage.removeItem(device.ip);
                    isPairingTriggeredFromLockPanel = true;
                    sendDeviceCommand(commandSent, "inApp");
                }
            } catch (e) {
                log("DEBUG", "unable to parse JSON");
            }

        }
    } catch (err) {
        log("ERROR", "Unable to initialize device info: " + err);
    }
}

function helloExchange(pairingValue) {
    try {

        let data = {
            "DEVICE_ID": _deviceId,
            "CHALLENGE_TYPE": 1,
            "RESPONSE_VALUE": pairingValue,
            "PAIRING_REQ_TOKEN": _pairingRequestToken
        };
        var method = "PUT";
        var payload = JSON.stringify(data);
        var url = `https://${device.ip}:9000/pairing/pair`;
        connectionState = "pair";
        var headersJsonMap = JSON.stringify({});
        removeRequestTimeout();
        requestTimeout = setTimeout(function () {
            log("ERROR", 'requestTimeout');
            // sendPairingResultEvent(false, device.type, device.brandName);
            toggleAlertMessage('block');
        }, 2000);
        var values;
        try {
            values = getContextIdAndSource(device.contextId);
            log("DEBUG", "Reading ContextId from client: " + values.contextId);
        } catch (error) {
            values = {
                "contextId": 151,
                "source": "inapp"
            }
            log("DEBUG", "Error Reading ContextId from client: " + values.contextId);            }

        log("DEBUG", "Came to sendHttpsRequestIgnoreSsl : " + payload);

        //sendHttpRequest(method, headersJsonMap, payload, url);
        Android.sendHttpsRequestIgnoreSsl(method, headersJsonMap, payload, url);
    } catch (err) {
        log("ERROR", "sendHttpRequest: No Android Interface:" + err);
    }
}

var storeAndSendPairingCode = function () {
    var pairingCode = document
        .getElementById("pairingValue")
        .value;
    log("DEBUG", "pairingCode: " + pairingCode);
    if (pairingCode !== '' || typeof pairingCode !== 'undefined') {
        log("DEBUG", "pairingCode: " + pairingCode);
        document
            .getElementById("pairingValue")
            .value = '';
        sendPairingEvent(device.type, device.brandName, "STARTED", "CONTROL_PAD");
        helloExchange(pairingCode);
    }
}

var checkIsPairingDone = function (deviceIp) {
    removeRequestTimeout();
    log("DEBUG", "deviceIp:" + device.ip);
    _authKey = localStorage.getItem(device.ip);
    log("DEBUG", "_authKey:" + _authKey);
    if (_authKey !== null) {
        isPaired = true;
        log("DEBUG", "pairingCode: not null");
        if (document.getElementById('pairingCodeBox')) {
            document
                .getElementById('pairingCodeBox')
                .style
                .display = 'none';
            document
                .getElementById('rectangle')
                .style
                .display = 'block';
        }
        sendDeviceCommand(commandSent, "inApp");
    } else {
        if (commandSentLocation === 'widget') {
            try {
                Android.openDeviceRemote(device.id);
            } catch (e) {
                log("DEBUG", "Android interface not found")
            }
        } else {
            log("DEBUG", "pairingCode: null");
            setTimeout(function () {
                document
                    .getElementById("pairingInputContainer")
                    .style
                    .display = 'block';
                document
                    .getElementById("alert-message")
                    .style
                    .display = 'none';
                document
                    .getElementById('pairingCodeBox')
                    .style
                    .display = 'block';
                document
                    .getElementById('rectangle')
                    .style
                    .display = 'none';
                if (!isPairingTriggeredFromLockPanel) {
                    sendPairingEvent(device.type, device.brandName, "TRIGGERED", "CONTROL_PAD");
                }
                showPairingKeyRequest();
            }, 100);
        }
    }
}

var closeDialog = function () {
    removeRequestTimeout();
    document
        .getElementById("pairingInputContainer")
        .style
        .display = 'none';
    document
        .getElementById("alert-message")
        .style
        .display = 'none';
    document
        .getElementById("pairingCodeBox")
        .style
        .display = 'none';
    document
        .getElementById("rectangle")
        .style
        .display = 'block';
}

function showPairingKeyRequest() {
    try {
        var method = "PUT";
        _deviceName = 'peel-smart-remote-' + new Date().getTime();
        _deviceId = 'peel-smart-remote-' + new Date().getTime();
        let data = {
            "DEVICE_NAME": _deviceName,
            "DEVICE_ID": _deviceId
        };
        var payload = JSON.stringify(data);
        var url = `https://${device.ip}:9000/pairing/start`;
        var headersJsonMap = JSON.stringify({});
        connectionState = "showKey";
        //sendHttpRequest(method, headersJsonMap, payload, url);
        Android.sendHttpsRequestIgnoreSsl(method, headersJsonMap, payload, url);
    } catch (err) {
        log("ERROR", "sendHttpRequest: No Android Interface:" + err);
    }
}

// start sreedhar d function local httpRequest
var xhr = new XMLHttpRequest();
function sendHttpRequest(method,headersJsonMap,payload,url)
{
    var mimeType = "application/json";
    xhr.open(method, url, true);
    xhr.setRequestHeader('Content-Type', mimeType);
    xhr.send(payload);

    xhr.onreadystatechange = processRequest;
}

function processRequest(e) {
    console.log("Status code" + xhr.status);
    console.log("Response Text: " + xhr.responseText);
    if (xhr.readyState == 4 && xhr.status == 200) {
        var response = JSON.parse(xhr.responseText);
        alert(response.ip);
    }
}
//end sreedhar code

var startTimer = function (event, command) {
    pressTimer = setTimeout(function () {
        sendVizioCommand(event, command);
        startTimer(event, command);
    }, 100);
}

var clearTimer = function () {
    clearTimeout(pressTimer);
}

var sendVizioCommand = function (event, command) {
    log("DEBUG", "sendVizioCommand: " + command);

    highlightingButtons(event, command);
    sendDeviceCommand(command, "inApp");
}

var checkToOpenDeviceRemoteInApp = function (command, commandSentLocation) {
    try {
        var storedData = localStorage.getItem(device.ip);
        log("DEBUG", "storedData: " + storedData);
        if (!storedData) {
            storedData = {};
            log("DEBUG", "storedData is null");
            storedData.commandSentLocation = commandSentLocation;
            storedData.commandSent = command;
            localStorage.setItem(device.ip, JSON.stringify(storedData));
            commandSentLocation = '';
            Android.openDeviceRemote(device.id);
            log("DEBUG", "openDeviceRemoteSent");
            return true;
        }
        log("DEBUG", "openDeviceRemoteSent");
    } catch (e) {
        log("DEBUG", "Android interface not found")
    }
    return false;
}

let keyData = (codeset, code, action) => {
    if (!action) {
        action = 'KEYPRESS';
    }
    return {
        KEYLIST: [
            {
                CODESET: codeset,
                CODE: code,
                ACTION: action
            }
        ]
    };
}

var keyCommand = function (codeset, code, action) {
    let data = keyData(codeset, code, action);
    return {"url": '/key_command/', "data": data};
}

var setCommand = function (command) {
    switch (command) {
        case 'Volume_Up':
            console.log(keyCommand(5, 1));
            return keyCommand(5, 1);
        case 'Volume_Down':
            return keyCommand(5, 0);
        case 'Power':
            return keyCommand(11, 2);
        case 'Mute':
            return keyCommand(5, 4);
        case 'Channel_Up':
            return keyCommand(8, 1);
        case 'Channel_Down':
            return keyCommand(8, 0);
        case 'Navigate_Up':
            return keyCommand(3, 8);
        case 'Navigate_Down':
            return keyCommand(3, 0);
        case 'Navigate_Left':
            return keyCommand(3, 1);
        case 'Navigate_Right':
            return keyCommand(3, 7);
        case 'Select':
            return keyCommand(3, 2);
        case 'Back':
            return keyCommand(4, 0);
        case 'Exit':
            return keyCommand(9, 0);
        case 'Menu':
            return keyCommand(4, 8);
        case 'Fast_Forward':
            return keyCommand(2, 0);
        case 'Skip_Back':
            return keyCommand(2, 1);
        case 'Play':
            return keyCommand(2, 3);
        case 'Pause':
            return keyCommand(2, 2);
        case 'info':
            return keyCommand(4, 6);
        case 'smartcast':
            return keyCommand(4, 3);
    }
}

var sendRequest = function (command) {
    var requestData = setCommand(command);
    try {
        var method = "PUT";
        var headersJsonMap = JSON.stringify({'AUTH': _authKey});
        var payload = JSON.stringify(requestData.data);
        var url = `https://${device.ip}:9000${requestData.url}`;
        //sendHttpRequest(method, headersJsonMap, payload, url);
        Android.sendHttpsRequestIgnoreSsl(method, headersJsonMap, payload, url);
    } catch (err) {
        log("ERROR", "sendHttpRequest: No Android Interface:" + err);
    }
}

var sendDeviceCommand = function (command, location) {

    var values;
    try {
        values = getContextIdAndSource(device.contextId);
    } catch (error) {
        values = {
            "contextId": 151,
            "source": "inapp"
        }
        log("DEBUG", "Error Sending ContextId from JS code on sendDeviceCommand: " + values.contextId);
    }
    log("DEBUG", "isPaired: " + isPaired);
    commandSentLocation = values.source;
    commandSent = command;
    if (location === 'widget') {
        if (checkToOpenDeviceRemoteInApp(command, location)) {
            sendPairingEvent(device.type, device.brandName, "TRIGGERED", "WIDGET");
            return;
        }
        log("DEBUG", "checking recursive");
    }
    removeRequestTimeout();
    requestTimeout = setTimeout(function () {
        log("ERROR", 'requestTimeout');
        toggleAlertMessage('block');
    }, 2000);
    if (!isPaired) {
        checkIsPairingDone();
        return;
    }
    log("DEBUG", "sendCommand: " + command);
    log("DEBUG", "isPaired: " + isPaired);
    sendRequest(command);
}

var disconnect = function () {
    toggleAlertMessage("block");
}

function getHttpResponse(value) {
    log("DEBUG", " HttpResponse:" + value);
    var httpResponseValues = value.split('|');
    var statusCode = httpResponseValues[1];
    var response = httpResponseValues[2].toString();
    var url = httpResponseValues[0];
    removeRequestTimeout();
    log("DEBUG", " statusCode:" + statusCode);
    log("DEBUG", " url:" + url);
    log("DEBUG", " deviceIp:" + device.ip);
    log("DEBUG", " response:" + response);
    log("DEBUG", " isPaired:" + isPaired);
    log("DEBUG", "device url: " + url);
    var urlpair = url.substr(0, url.lastIndexOf("/"));
    switch (urlpair) {
        case 'https://' + device.ip + ':9000/pairing':
            log("DEBUG", " pairing statusCode: " + statusCode);
            switch (connectionState) {
                case "showKey":
                    log("DEBUG", "Reached to showKey and status is " + statusCode);
                    connectionState = '';
                    if (parseInt(statusCode) === 200) {
                        log("DEBUG", "Reached before send pairing event");
                        sendPairingEvent(device.type, device.brandName, "SHOWN", "CONTROL_PAD");
                        log("DEBUG", "Reached after send pairing event");
                        try {
                            log("DEBUG","after send pairing event response is" + response );
                            log("DEBUG","after send pairing event httpResponseValues is" + httpResponseValues );
                            response = JSON.parse(response);
                            log("DEBUG", "_pairingRequestToken: " + response.ITEM.PAIRING_REQ_TOKEN);
                            _pairingRequestToken = response.ITEM.PAIRING_REQ_TOKEN;
                        } catch (error) {
                            log("ERROR", "unable to parse response");
                        }
                    } else {
                        sendPairingResultEvent(false, device.type, device.brandName);
                    }
                    return;
                case "pair":
                    connectionState = '';
                    if (parseInt(statusCode) === 200) {
                        isPaired = true;
                        sendPairingResultEvent(true, device.type, device.brandName);
                        toggleAlertMessage("none");
                        if (document.getElementById("pairingInputContainer")) {
                            document
                                .getElementById("pairingInputContainer")
                                .style
                                .display = 'none';
                            document
                                .getElementById("alert-message")
                                .style
                                .display = 'none';
                            document
                                .getElementById("pairingCodeBox")
                                .style
                                .display = 'none';
                            document
                                .getElementById("rectangle")
                                .style
                                .display = 'block';
                        }
                        log("DEBUG", "Reached to pair and response is " + response);
                        try {
                            response = JSON.parse(response);
                            _authKey = response.ITEM.AUTH_TOKEN;
                            log("DEBUG", "_authKey: " + _authKey);
                            localStorage.setItem(device.ip, _authKey);
                            sendDeviceCommand(commandSent, "inApp");
                        } catch (error) {
                            log("ERROR", "unable to parse response inside pair case");
                        }
                    } else if (parseInt(statusCode) === 401) {
                        isPaired = false;
                        sendPairingResultEvent(false, device.type, device.brandName);
                        localStorage.removeItem(device.ip);
                        checkIsPairingDone(device.ip);
                    } else if (parseInt(statusCode) === 400) {
                        isPaired = false;
                        sendPairingResultEvent(false, device.type, device.brandName);
                        toggleAlertMessage("block");
                    }
                    break;
            }
            break;
        case 'https://' + device.ip + ':9000/key_command':
            log("DEBUG", " sendCommand statusCode: " + statusCode + typeof statusCode);
            log("DEBUG", " sendCommand: " + commandSent);
            if (parseInt(statusCode) === 200) {
                toggleAlertMessage("none");
                try {
                    log("DEBUG", "Calling  sendCommandDetailSentEvent reached here");
                    sendCommandDetailSentEvent(true, commandSent, device.contextId, getSource(device.contextId));
                    log("DEBUG", "Sending ContextId from JS code: " + device.contextId);
                } catch (error) {
                    sendInsightEvent(true, commandSent);
                    log("DEBUG", "Sending sendInsightEvent: true: " + commandSent);
                }
            } else if (parseInt(statusCode) === 401) {
                try {
                    sendCommandDetailSentEvent(false, commandSent, values.contextId, values.source);
                    log("DEBUG", "Sending ContextId from JS code: " + values.contextId);
                } catch (error) {
                    sendInsightEvent(false, commandSent);
                    log("DEBUG", "Sending sendInsightEvent: false: " + commandSent);
                }
                isPaired = false;
                checkIsPairingDone();
            } else {
                try {
                    sendCommandDetailSentEvent(false, command, values.contextId, values.source);
                    log("DEBUG", "Sending ContextId from JS code: " + values.contextId);
                } catch (error) {
                    sendInsightEvent(false, commandSent);
                    log("DEBUG", "Sending sendInsightEvent: false: " + commandSent);
                }
                toggleAlertMessage("block");
            }
            break;
    }
}

function getInfo(value) {
    var info = "empty";
    switch (value) {
        case "currentDevice":
            info = Android.getCurrentDeviceInfo();
            break;
        case "currentActivity":
            info = Android.getCurrentActivityInfo();
            break;
        case "currentRoom":
            info = Android.getCurrentRoomInfo();
            break;
    }
    return info;
}